'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _postcss = require('postcss');

var _postcss2 = _interopRequireDefault(_postcss);

var _postcssImport = require('postcss-import');

var _postcssImport2 = _interopRequireDefault(_postcssImport);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var importRegexp = /\:import\(['"](.*)['"]\)/;

function importModule(css, result) {
  css.each(function (importRule) {
    var match = importRegexp.exec(importRule.selector);

    if (!match) return;

    var moduleName = match[1];
    css.prepend({ name: 'import', params: '"' + moduleName + '"' });
  });

  var plugins = result.processor.plugins.filter(function (plugin) {
    return ['postcss-modules:cleanUnusedClasses', 'postcss-modules:cleanImportAndExportRules', 'postcss-modules:getExports', 'postcss-modules'].indexOf(plugin.postcssPlugin) === -1;
  });

  // Replace @import directives with imported modules
  (0, _postcssImport2.default)({ plugins: plugins })(css, result);
}

exports.default = _postcss2.default.plugin('postcss-modules:importModule', function () {
  return importModule;
});