'use strict';

var _postcss = require('postcss');

var _postcss2 = _interopRequireDefault(_postcss);

var _cssModulesLoaderCore = require('css-modules-loader-core');

var _cssModulesLoaderCore2 = _interopRequireDefault(_cssModulesLoaderCore);

var _generateScopedName = require('./generateScopedName');

var _generateScopedName2 = _interopRequireDefault(_generateScopedName);

var _getExports = require('./getExports');

var _getExports2 = _interopRequireDefault(_getExports);

var _addGlobalComments = require('./addGlobalComments');

var _addGlobalComments2 = _interopRequireDefault(_addGlobalComments);

var _cleanImportAndExportRules = require('./cleanImportAndExportRules');

var _cleanImportAndExportRules2 = _interopRequireDefault(_cleanImportAndExportRules);

var _cleanUnusedClasses = require('./cleanUnusedClasses');

var _cleanUnusedClasses2 = _interopRequireDefault(_cleanUnusedClasses);

var _importModules = require('./importModules');

var _importModules2 = _interopRequireDefault(_importModules);

var _applyImports = require('./applyImports');

var _applyImports2 = _interopRequireDefault(_applyImports);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = _postcss2.default.plugin('postcss-modules', function () {
  var opts = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var scope = _cssModulesLoaderCore2.default.scope;
  scope.generateScopedName = opts.generateScopedName || _generateScopedName2.default;

  return (0, _postcss2.default)([_addGlobalComments2.default, _cssModulesLoaderCore2.default.localByDefault(), _cssModulesLoaderCore2.default.extractImports(), _cssModulesLoaderCore2.default.scope(), _importModules2.default, _applyImports2.default, _postcss2.default.plugin('postcss-modules:getExports', function () {
    return function (css) {
      var filename = css.source.input.file;
      if (opts.getJSON) opts.getJSON(filename, (0, _getExports2.default)(css));
    };
  }), _cleanUnusedClasses2.default, _cleanImportAndExportRules2.default]);
});